/*
** HDL4SE: 软件Verilog综合仿真平台
** Copyright (C) 2021-2021, raoxianhong<raoxianhong@163.net>
** LCOM: 轻量级组件对象模型
** Copyright (C) 2021-2021, raoxianhong<raoxianhong@163.net>
** All rights reserved.
**
** Redistribution and use in source and binary forms, with or without
** modification, are permitted provided that the following conditions are met:
**
** * Redistributions of source code must retain the above copyright notice,
**   this list of conditions and the following disclaimer.
** * Redistributions in binary form must reproduce the above copyright notice,
**   this list of conditions and the following disclaimer in the documentation
**   and/or other materials provided with the distribution.
** * The name of the author may be used to endorse or promote products
**   derived from this software without specific prior written permission.
**
** THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
** AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
** IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
** ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE
** LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
** CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
** SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
** INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
** CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
** ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF
** THE POSSIBILITY OF SUCH DAMAGE.
*/

#include "stdlib.h"
#include "stdio.h"
#include "object.h"
#include "bignumber.h"

const char* testnumber = "77'h4137489137419837408139048137908791875841983274987132, 43, 4, 128'b0101011111011010100011000101010101010100010101010101010001, 'h94397afc4343, 5'd98";

int main(int argc, char* argv[])
{
	char buf[128];
	IBigNumber** bignumber = bigintegerCreate(100);
	IBigNumber** bignumber2 = bigintegerCreate(20);
	const char* nstr = testnumber;
	const char* lstr = testnumber;
	/*
	while (0 == objectCall3(bignumber, AssignStr, lstr, &nstr, 1)) {
		objectCall3(bignumber, GetStr, 16, buf, 128);
		printf("%s=%s, \nnext=%s\n", lstr, buf, nstr);
		lstr = nstr;
	}
	*/
	objectCall1(bignumber, AssignInt64, 0x102435425566ll);
	objectCall3(bignumber, GetStr, 16, buf, 256);
	printf("n=%s\n", buf);
	objectCall2(bignumber, AddInt32, bignumber, -12);
	objectCall3(bignumber, GetStr, 16, buf, 256);
	printf("n=%s\n", buf);
	objectCall1(bignumber2, AssignInt32, -12524);
	objectCall3(bignumber2, GetStr, 16, buf, 256);
	printf("n=%s\n", buf);
	objectCall2(bignumber, Mul, bignumber, bignumber2);
	objectCall3(bignumber, GetStr, 16, buf, 256);
	printf("n=%s\n", buf);
	objectCall2(bignumber, SHR, bignumber, 8);
	objectCall3(bignumber, GetStr, 16, buf, 256);
	printf("n=%s\n", buf);
	return 0;
}